package com.bwie.manage.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.bwie.common.constants.TokenConstants;
import com.bwie.common.domain.Manage;
import com.bwie.common.domain.User;
import com.bwie.common.result.Result;
import com.bwie.common.utils.JwtUtils;
import com.bwie.manage.mapper.ManageMapper;
import com.bwie.manage.service.ManageService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

@Service
public class ManageServiceCs implements ManageService {
    @Autowired
    private ManageMapper manageMapper;

    @Autowired
    private RedisTemplate<String ,String > redisTemplate;
    @Autowired
    private HttpServletRequest request;
    @Override
    public Result list() {
        List<Manage> list = manageMapper.list();
        return Result.success(list,"列表");
    }

    @Override
    public Result add(Manage manage) {

        String token = request.getHeader("token");
        String userKey = JwtUtils.getUserKey(token);
        String s = redisTemplate.opsForValue().get(TokenConstants.LOGIN_TOKEN_KEY + userKey);
        User user = JSONObject.parseObject(s, User.class);
        manage.setId(user.getId());
        Manage all = manageMapper.findAll(manage);
        if (all!=null){
            return Result.error("存在此病人不能添加");
        }
        Integer add=manageMapper.add(manage);
        return Result.success(add>0?200:500,add>0?"添加成功":"添加失败");
    }

    @Override
    public Result upd(Manage manage) {
        Integer upd=manageMapper.upd(manage);
        return Result.success(upd>0?200:500,upd>0?"添加成功":"添加失败");
    }

    @Override
    public Result del(Integer manageId) {
        Integer del=manageMapper.del(manageId);
        return Result.success(del>0?200:500,del>0?"添加成功":"添加失败");
    }
}
